/******************************************************************************
 *
 * Copyright (c) 1999	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	ScrollBar.h
 *
 *****************************************************************************/

// SOL++2000
// 2000.02.18

#ifndef _SOL_PRIMITIVE
#include <sol\Primitive.h>
#endif

#ifndef _SOL_SCROLLBAR
#define _SOL_SCROLLBAR

class ScrollBar	:public Primitive {
	int		pageIncrement;
	int		lineIncrement;
  public:
	static	int HORIZONTAL;
	static  int	VERTICAL;
  protected:
	LRESULT	defaultProc(Event& event);
 
  public:
	ScrollBar():Primitive() { }
	  
	ScrollBar(View* parent, const char* name, Args& args);

	virtual Boolean create(View* parent, const char* name, Args& args);

	int		getPos() {
			return ::GetScrollPos(getWindow(), SB_CTL);
	}
	void	disable();
	void	enable();
	void	getScrollRange(int* min, int* max) {
	 		::GetScrollRange(getWindow(), SB_CTL, min, max);
	}
	void	getValues(Args& args);
	int		moveThumb(Event& event);
	void 	setPos(int pos) {
			::SetScrollPos(getWindow(), SB_CTL, pos, TRUE);
	}
	int		getPageIncrement() { return pageIncrement; }
	int		getLineIncrement() { return lineIncrement; }
	void	setScrollRange(int min, int max) {
	 		::SetScrollRange(getWindow(), SB_CTL, min, max, TRUE);
	}

	void	setPageIncrement(int val) { pageIncrement = val; }
	void	setLineIncrement(int val) { lineIncrement = val; }
	void	setValues(Args& args);

	void    enableArrows(int arrows) {
			send(SBM_ENABLE_ARROWS, (WPARAM)arrows, 0L);
	}
	void	getRange(int* min, int* max) {
	 		send(SBM_GETRANGE, (WPARAM)min, (LPARAM)max);
	}
	void	setRange(int min, int max) {
	 		send(SBM_SETRANGE, (WPARAM)min, (LPARAM)max);
	}
	void	setRangeRedraw(int min, int max) {
	 		send(SBM_SETRANGEREDRAW, (WPARAM)min, (LPARAM)max);
	}
	BOOL	getScrollInfo(SCROLLINFO* scInfo);
	int		setScrollInfo(SCROLLINFO* scInfo);
};

#endif

